local PotButton_EventFrame, events = CreateFrame("FRAME"), {}
local PotButton_ChangeInitiated = false
local PotButton_Timer = 0
local PotButton_TimerInterval = .1
local PotButton_AddonIsLoaded = false
local PotButton_MacrosAreLoaded = false
local PotButton_EnteredWorld = false
--------------------------------------------------------------------
function events:ADDON_LOADED(...)
	local addonName = ...
	if addonName == "PotButton" then
		PotButton_AddonIsLoaded = true
		PotButton_Init()
		PotButton_EventFrame:UnregisterEvent("ADDON_LOADED")
	end
end
--------------------------------------------------------------------
function events:UPDATE_MACROS(...)
	PotButton_MacrosAreLoaded = true
	PotButton_Init()
	PotButton_EventFrame:UnregisterEvent("UPDATE_MACROS")
end
--------------------------------------------------------------------
function events:PLAYER_ENTERING_WORLD(...)
	PotButton_EnteredWorld = true
	PotButton_Init()
	PotButton_EventFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
end
--------------------------------------------------------------------
PotButton_EventFrame:SetScript("OnEvent", function(self, event, ...)
	events[event](self, ...)
end)
--------------------------------------------------------------------
for i, v in pairs(events) do
	PotButton_EventFrame:RegisterEvent(i)
end
--------------------------------------------------------------------
PotButton_EventFrame:SetScript("OnUpdate", function(self, elapsed)
	PotButton_Timer = PotButton_Timer + elapsed
	if PotButton_Timer > PotButton_TimerInterval then
		PotButton_UpdateButton()
		PotButton_Timer = 0
	end
end)
--------------------------------------------------------------------
SLASH_SETPOTIONBTN1 = "/setpot"
function SlashCmdList.SETPOTIONBTN(msg, editbox, ...)
	local spArgv, _ = SecureCmdOptionParse(msg)
	if (spArgv == nil or not CursorHasItem()) then return end

	local btns = ...
	local ctrlPressed = IsControlKeyDown()
	local altPressed = IsAltKeyDown()

	local itemName = ""
	local infoType, itemID = GetCursorInfo()
	if infoType == "item" then
		itemName = GetItemInfo(itemID)
	end

	if itemName ~= "" then
		if not ctrlPressed and not altPressed then
			PotButton.nomod = itemName
		elseif ctrlPressed then
			PotButton.ctrl = itemName
		else
			PotButton.alt = itemName
		end

		PotButton_ChangeInitiated = true
	end
end
--------------------------------------------------------------------
function PotButton_Init()
	if PotButton_AddonIsLoaded and PotButton_MacrosAreLoaded and PotButton_EnteredWorld then
		if not PotButton then PotButton = {} end
		if not PotButton.nomod then PotButton.nomod = "" end
		if not PotButton.ctrl then PotButton.ctrl = "" end
		if not PotButton.alt then PotButton.alt = "" end
		PotButton_ChangeInitiated = true
	end
end
--------------------------------------------------------------------
function PotButton_UpdateButton()
	if PotButton_ChangeInitiated and not UnitAffectingCombat("player") then
		local btnName = "Pot"
		local btnText = "#showtooltip\n/cast "

		if PotButton.nomod ~= "" or PotButton.ctrl ~= "" or PotButton.alt ~= "" then
			btnText = btnText .. "[mod:ctrl,mod:alt,"
		else
			btnText = btnText .. "["
		end
		btnText = btnText .. "nomod:shift] Healthstone"

		if PotButton.alt ~= "" then
			btnText = btnText .. "; ["
			if PotButton.nomod ~= "" then
				btnText = btnText .. "mod:alt"
				btnText = btnText .. (PotButton.ctrl == "" and "/ctrl" or "")
				btnText = btnText .. ","
			end
			btnText = btnText .. "nomod:shift] " .. PotButton.alt
		end

		if PotButton.ctrl ~= "" then
			btnText = btnText .. "; ["
			if PotButton.nomod ~= "" then
				btnText = btnText .. "mod:ctrl"
				btnText = btnText .. (PotButton.alt == "" and "/alt" or "")
				btnText = btnText .. ","
			end
			btnText = btnText .. "nomod:shift] " .. PotButton.ctrl
		end

		if PotButton.nomod ~= "" then
			btnText = btnText .. "; [nomod:shift] " .. PotButton.nomod
		end

		btnText = btnText .. "\n/setpot [mod:shift]"

		if not GetMacroInfo(btnName) then
			CreateMacro(btnName, "INV_MISC_QUESTIONMARK", btnText, nil)
		else
			EditMacro(btnName,btnName, nil, btnText, 1, 1)
		end

		PotButton_ChangeInitiated = false
	end
end